﻿UsePNGImageEncoder()
#fl=72*720
;#m=255
Global *f=AllocateMemory(#fl+1)

Enumeration
  #file_save
  #file_open
  #file_about
  #file_quit
EndEnumeration

Procedure loadp(f$)
  fs=FileSize(f$)
  If ReadFile(0,f$)
    *m=AllocateMemory(fs)
    ReadData(0,*m,fs)
    CloseFile(0)
    
    p.l=640
    If PeekS(*m+$41,4,#PB_Ascii)<>"PNTG"
      p-128
    EndIf
    n.l=0
    FillMemory(*f,#fl,$FF,#PB_Byte)
    
    ;  Debug PeekS(*m+$41,4,#PB_Unicode)
    ; ShowMemoryViewer(*m+$41,1024)
    ;  CreateFile(1,"prb.bin")
    While p<fs
      c.a=PeekA(*m+p)
      p+1
      If c&128
        c=-c+1
        a.a=PeekA(*m+p)!255
        p+1
        For j=1 To c
          ;      WriteAsciiCharacter(1,a)
          If n<#fl
            PokeA(*f+n,a)
            n+1
          EndIf
        Next j
      Else
        For j=0 To c
          ;      WriteAsciiCharacter(1,PeekA(*m+p)!#m)
          If n<#fl
            PokeA(*f+n,PeekA(*m+p)!255)
            n+1
          EndIf
          p+1
        Next j
      EndIf
      ;     Debug p
      If n>#fl
        Break
      EndIf
    Wend
    ; CloseFile(1)
    FreeMemory(*m)
    
    StartDrawing(ImageOutput(0))
    Box(0,0,576,220,$FFFFFF)
    n=0
    For y=0 To 719
      For x=0 To 71
        a.a=PeekA(*f+n);!255
        n+1
        b.a=128
        For i=0 To 7
          If a&b
            cl=$FFFFFF
          Else
            cl=0
          EndIf
          Box(x*8+i,y,1,1,cl)
          b>>1
        Next i
      Next x
    Next y
    StopDrawing()
    
    If StartDrawing(CanvasOutput(0))
      DrawImage(ImageID(0),0,0)
      StopDrawing()
    EndIf
    
  EndIf
  
EndProcedure

If OpenWindow(0, 0, 0, 576, 720, "MacPaint view", #PB_Window_SystemMenu | #PB_Window_ScreenCentered| #PB_Window_MinimizeGadget)
  CanvasGadget(0, 0, 0, 576, 720)
  CreateImage(0,576,720)  
  
  EnableGadgetDrop(0,#PB_Drop_Files,#PB_Drag_Copy)
  If CountProgramParameters()
    loadp( ProgramParameter(0) )
  EndIf
  
  If CreatePopupMenu(0)
    MenuItem(#file_save, "Save image")
    MenuItem(#file_open, "Open .MAC")
    MenuBar()
    MenuItem(#file_about, "About..")
    MenuBar()
    MenuItem(#file_quit, "Quit")
  EndIf
  ;loadp("cactus.MAC")
  
  Repeat
    Event = WaitWindowEvent()
    If GetAsyncKeyState_(#VK_ESCAPE)&32768;=-32767
      Break
    EndIf
    Select Event
      Case #PB_Event_Gadget
        Select EventGadget()
          Case 0
            If EventType() = #PB_EventType_RightButtonDown
              If IsMenu(0)
                DisplayPopupMenu(0,WindowID(0))
              EndIf
            EndIf
        EndSelect
        
      Case #PB_Event_Menu
        Select EventMenu()
          Case #file_save:
              StandardFile$ = ""   ; set initial file+path to display
  Pattern$ = "Bitmap (*.bmp)|*.bmp|PNG (*.png)"
  File$ = SaveFileRequester("Please choose file to save", StandardFile$, Pattern$, 0)
  If File$
    e$="";extension
    pl.l=#PB_ImagePlugin_BMP
    Select SelectedFilePattern()
        Case 0: e$=".bmp"
        Case 1: e$=".png"
          pl=#PB_ImagePlugin_PNG
      EndSelect
      If e$<>""
        ex.s=Mid(File$,Len(File$)-3)
        If LCase(ex)<>e$
          File$+e$
        EndIf
      EndIf
      SaveImage(0,File$,pl)
  EndIf


          Case #file_open:
            StandardFile$ = ""   ; set initial file+path to display
            Pattern$ = "macpaint (*.mac)|*.mac"
            Pattern = 0    ; use the first of the three possible patterns as standard
            File$ = OpenFileRequester("Please choose file to load", StandardFile$, Pattern$, 0)
            If File$
              loadp(File$)
            EndIf
            
            
          Case #file_about:
            MessageRequester("About","MacPaint image viewer"+#CRLF$+"by g0blinish")
          Case #file_quit : Break
        EndSelect
        
      Case #PB_Event_GadgetDrop
        Files$ = EventDropFiles()
        File$ = StringField(Files$, 1, Chr(10))
        loadp(file$)
    EndSelect
  Until Event = #PB_Event_CloseWindow
EndIf
FreeMemory(*f)

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 134
; FirstLine = 117
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = macpv.ico
; Executable = macpv.exe
; CommandLine = cactus.mac